Index: s390-tools-sles11/ziomon/ziorep_config
===================================================================
--- /dev/null
+++ s390-tools-sles11/ziomon/ziorep_config
@@ -0,0 +1,492 @@
+#!/usr/bin/perl
+
+#
+# FCP report generators
+#
+# Script to list the FCP, SCSI and multipath configuration
+#
+# Copyright IBM Corp. 2008.
+# Author(s): Swen Schillig    <swen@vnet.ibm.com>
+#
+
+use strict;
+use warnings;
+use English;
+use Getopt::Long;
+use File::Spec::Functions;
+use File::Temp qw/ tempdir /;
+use Data::Dumper;
+
+use constant S_DIR1 => "/sys/class/fc_host";
+use constant S_DIR2 => "/sys/devices/css0"; #/<sub_ch>/<device>
+use constant S_DIR3 => "/sys/class/scsi_device";
+use constant S_DIR4 => "/sys/class/fc_remote_ports";
+
+our $base_dir = "/";
+our %sub_ch;
+our %devices;
+our %mapper_dev;
+our %rports;
+our $c_src;
+
+sub get_line
+{
+	return "n/a" unless open(FH, (catfile($c_src, @_))[0]);
+	my $line = readline(FH);
+	$line =~ s/\s*\Z// unless !$line;
+	close(FH);
+	return $line;
+}
+
+sub dir_content
+{
+	my @temp_dir;
+	opendir(DH, shift()) or return 0;
+	@temp_dir = readdir(DH);
+	closedir(DH);
+	return @temp_dir;
+}
+
+sub glob_last
+{
+	return (glob(catfile($c_src, @_)))[-1];
+}
+
+sub mm_to_32
+{
+	return "0" unless ($_[0] and $_[0] =~ /\d+:\d+/);
+	my @t_arr = split(':',shift);
+	return ($t_arr[0] << 20) + $t_arr[1];
+}
+
+sub get_sub_ch_data
+{
+	my @entries = grep { /^host\d+\Z/ }
+			dir_content(catdir($base_dir, S_DIR1));
+
+	foreach my $host (@entries) {
+		$c_src = catdir($base_dir, S_DIR1, $host);
+		my $sub_ch;
+		my $adapter;
+		if (-l $c_src) {
+			$sub_ch = (split("/", readlink($c_src)))[-5];
+			$adapter = (split("/", readlink($c_src)))[-4];
+		} else {
+			$sub_ch = (split("/", readlink($c_src."/device")))[-3];
+			$adapter = (split("/", readlink($c_src."/device")))[-2];
+		}
+		$sub_ch{$adapter}{sub_ch} = $sub_ch;
+		$sub_ch{$adapter}{host}  = $host;
+		$sub_ch{$adapter}{speed} = get_line("speed");
+		$sub_ch{$adapter}{name}  = get_line("port_name");
+		$sub_ch{$adapter}{pname} = get_line("permanent_port_name");
+		$sub_ch{$adapter}{type}  = get_line("port_type");
+		$c_src = catdir($base_dir, S_DIR2, $sub_ch, $adapter);
+		$sub_ch{$adapter}{lic}   = get_line("lic_version");
+		$sub_ch{$adapter}{gen}   = get_line("card_version");
+		$sub_ch{$adapter}{state} = get_line("online") == 1 ? "Online" :
+								     "Offline";
+		$c_src = catdir($base_dir, S_DIR2, $sub_ch);
+		$sub_ch{$adapter}{chpid} = substr(get_line("chpids"), 0, 2);
+	}
+}
+
+sub get_device_data
+{
+	my @entries = grep { /^\d+:\d+:\d+:\d+\Z/ }
+			dir_content(catdir($base_dir, S_DIR3));
+
+	foreach my $hctl (@entries) {
+		$c_src = catdir($base_dir, S_DIR3, $hctl, "device");
+		my $type =  get_line("type");
+		$devices{$hctl}{hba_id} = get_line("hba_id");
+		$devices{$hctl}{model}  = get_line("model");
+		$devices{$hctl}{vendor} = get_line("vendor");
+		$devices{$hctl}{lun}    = get_line("fcp_lun");
+		$devices{$hctl}{wwpn}   = get_line("wwpn");
+		$devices{$hctl}{sg} = (-d catdir($c_src, "scsi_generic")) ?
+					glob_last(catdir("scsi_generic/*")) :
+					glob_last("scsi_generic\:*");
+
+		$devices{$hctl}{sg}     =~ s/.*(sg\d+)\Z/$1/
+					unless(!$devices{$hctl}{sg});
+		$devices{$hctl}{type}   = "type_".$type; #preset only
+		$devices{$hctl}{mm}     = "0:0"; #preset only
+		$devices{$hctl}{sg_mm}  = "0:0"; #preset only
+		$devices{$hctl}{dev}    = undef; #preset only
+		if ($type == "0") {
+			$devices{$hctl}{type} = "Disk";
+			if (-d catdir($c_src, "block")) {
+				$devices{$hctl}{dev}  = glob_last("block/sd*");
+			} else {
+				$devices{$hctl}{dev}  = glob_last("block\:sd*");
+			}
+			$c_src = $devices{$hctl}{dev};
+			$devices{$hctl}{dev}  =~ s/.*(sd[a-z0-9]+)\Z/$1/
+						unless(!$devices{$hctl}{dev});
+			$devices{$hctl}{mm}   = get_line("dev");
+			$devices{$hctl}{sg_mm}   = get_line("generic", "dev");
+			$devices{$hctl}{mp_dev} = glob_last("holders", "dm*");
+			$devices{$hctl}{mp_dev} =~ s/.*\/(.+)\Z/$1/
+						unless (!$devices{$hctl}{mp_dev});
+			$c_src = catdir($base_dir, "sys", "block",
+					$devices{$hctl}{mp_dev});
+			$devices{$hctl}{mp_dev_mm} = get_line("dev");
+		} elsif ($type == "1") {
+			$devices{$hctl}{type} = "Tape";
+			$devices{$hctl}{mm} = get_line("tape", "dev");
+			$devices{$hctl}{sg_mm} = get_line("generic", "dev");
+			$devices{$hctl}{dev} = (-d catdir($c_src, "scsi_tape")) ?
+						(grep { /st\d+\Z/ }
+                                                glob(catdir($c_src, "scsi_tape/st*")))[0] :
+						(grep { /\:st\d+\Z/ }
+						glob(catdir($c_src, "scsi_tape:st*")))[0];
+			$devices{$hctl}{dev} =~ s/.*(st\d+)\Z/$1/
+						unless(!$devices{$hctl}{dev});
+		}
+	}
+}
+
+sub get_mapper_devices
+{
+	$c_src = catdir($base_dir, "dev", "mapper");
+	my @entries = grep { ! /^\./ } dir_content($c_src);
+
+	foreach my $dev (@entries) {
+		next if ("control" =~ /$dev/);
+		if ($base_dir !~ /^\/\Z/) {
+			$mapper_dev{get_line("$dev")} = $dev;
+			next;
+		}
+		my $tf = catfile($c_src, "$dev");
+		my $mm = `stat -c%t:%T $tf`;
+		chomp($mm);
+		$mm = join(":", map { hex($_) } split(":", $mm));
+		$mapper_dev{$mm} = $dev;
+	}
+}
+
+sub get_rport_data
+{
+	my @entries = grep { ! /^\./ } dir_content(catdir($base_dir, S_DIR4));
+
+	foreach my $rport (@entries) {
+		$c_src = catdir($base_dir, S_DIR4, "$rport");
+		$rports{$rport}{wwpn} = get_line("port_name");
+		$rports{$rport}{did} = get_line("port_id");
+		$rports{$rport}{sup_class} = get_line("supported_classes");
+		$rports{$rport}{scsi_target} = get_line("scsi_target_id");
+		$rports{$rport}{dl_tmo} = get_line("dev_loss_tmo");
+		$rports{$rport}{state} = get_line("port_state");
+		$rports{$rport}{hba_id} = (split('/', get_line("uevent")))[-1];
+	}
+}
+
+sub mapping_table
+{
+	foreach my $line (sort keys %devices) {
+		my @out_str;
+		my $mp_dev_mm = $devices{$line}{mp_dev_mm};
+
+		push @out_str, $sub_ch{$devices{$line}{hba_id}}{chpid};
+		push @out_str, $line;
+		push @out_str, "$sub_ch{$devices{$line}{hba_id}}{sub_ch}:".
+			       "$devices{$line}{hba_id}:$devices{$line}{wwpn}:".
+				$devices{$line}{lun};
+		if ($mp_dev_mm && defined $mapper_dev{$mp_dev_mm}) {
+			push @out_str, "/dev/mapper/$mapper_dev{$mp_dev_mm}";
+			push @out_str, mm_to_32($devices{$line}{mp_dev_mm});
+			push @out_str, "$devices{$line}{mp_dev_mm}";
+		} else {
+			push @out_str, "n/a";
+			push @out_str, "0";
+			push @out_str, "0:0";
+		}
+		if ($devices{$line}{type} eq "Tape") {
+			push @out_str, $devices{$line}{dev} ? "/dev/$devices{$line}{sg}" : "n/a" ;
+			push @out_str, mm_to_32($devices{$line}{sg_mm});
+			push @out_str, $devices{$line}{sg_mm};
+		} else {
+			push @out_str, $devices{$line}{dev} ? "/dev/$devices{$line}{dev}" : "n/a" ;
+			push @out_str, mm_to_32($devices{$line}{mm});
+			push @out_str, $devices{$line}{mm};
+		}
+		push @out_str, $devices{$line}{type};
+		print "@out_str\n";
+	}
+}
+
+sub adapter_report
+{
+	my @adapters = @_;
+
+	foreach my $a (sort keys %sub_ch) {
+		next if (@adapters && "@adapters" !~ /\b$a\b/);
+		my @out_str;
+		push @out_str, "Host:    $sub_ch{$a}{host}\n";
+		push @out_str, "CHPID:   $sub_ch{$a}{chpid}\n";
+		push @out_str, "Adapter: $a\n";
+		push @out_str, "Sub-Ch.: $sub_ch{$a}{sub_ch}\n";
+		push @out_str, "Name:    $sub_ch{$a}{name}\n";
+		push @out_str, "P-Name:  $sub_ch{$a}{pname}\n";
+		push @out_str, "Version: $sub_ch{$a}{gen}\n";
+		push @out_str, "LIC:     $sub_ch{$a}{lic}\n";
+		push @out_str, "Type:    $sub_ch{$a}{type}\n";
+		push @out_str, "Speed:   $sub_ch{$a}{speed}\n";
+		push @out_str, "State:   $sub_ch{$a}{state}\n";
+		print @out_str, "\n";
+	}
+}
+
+sub device_report
+{
+	my $adapters = shift;
+	my $ports = shift;
+	my $luns = shift;
+	my $s_devs = shift;
+	my $hosts = shift;
+
+	if ($_[0]) {
+		print "adapter  remote_port        LUN                SCSI  ",
+		      "gen_dev  scsi_dev MM  type model vendor H:C:T:L\n",
+		      "======================================================",
+		      "===============================================\n";
+	}
+	foreach my $hctl (sort keys %devices) {
+		next if (@$adapters && "@$adapters" !~ /\b$devices{$hctl}{hba_id}\b/);
+		next if (@$ports && "@$ports" !~ /\b$devices{$hctl}{wwpn}\b/);
+		next if (@$luns && "@$luns" !~ /\b$devices{$hctl}{lun}\b/);
+		next if (@$s_devs && "@$s_devs" !~ /\b$devices{$hctl}{dev}\b/);
+		next if (@$hosts && "@$hosts" !~ /\b$sub_ch{$devices{$hctl}{hba_id}}{host}\b/);
+		my @out_str;
+		push @out_str, $devices{$hctl}{hba_id};
+		push @out_str, $devices{$hctl}{wwpn};
+		push @out_str, $devices{$hctl}{lun};
+		push @out_str, $sub_ch{$devices{$hctl}{hba_id}}{host};
+		push @out_str, "/dev/".$devices{$hctl}{sg};
+		push @out_str, $devices{$hctl}{dev} ?
+					"/dev/".$devices{$hctl}{dev}: "NO_SCSI";
+		push @out_str, $devices{$hctl}{mm};
+		push @out_str, $devices{$hctl}{type};
+		push @out_str, $devices{$hctl}{model};
+		push @out_str, $devices{$hctl}{vendor};
+		push @out_str, $hctl;
+
+		print "@out_str\n";
+	}
+}
+
+sub mapper_report
+{
+	my $adapters = shift;
+	my $ports = shift;
+	my $s_devs = shift;
+	my $m_devs = shift;
+	my @out_str;
+
+	if (! (keys %mapper_dev)) {
+		print "No device mapper devices configured.\n";
+		return;
+	}
+	if ($_[0]) {
+		print "adapter  remote_port        scsi_dev multipath_device\n",
+		      "=====================================================\n";
+	}
+	foreach my $hctl (sort keys %devices) {
+		next if (! $devices{$hctl}{mp_dev_mm});
+		next if (@$adapters && "@$adapters" !~ /\b$devices{$hctl}{hba_id}\b/);
+		next if (@$ports && "@$ports" !~ /\b$devices{$hctl}{wwpn}\b/);
+		next if (@$s_devs && "@$s_devs" !~ /\b$devices{$hctl}{dev}\b/);
+		next if (@$m_devs && "@$m_devs" !~ /\b$mapper_dev{$devices{$hctl}{mp_dev_mm}}\b/);
+		my @line_str;
+		push @line_str, $devices{$hctl}{hba_id};
+		push @line_str, $devices{$hctl}{wwpn};
+		push @line_str, "/dev/".$devices{$hctl}{dev};
+		push @line_str, "/dev/mapper/".$mapper_dev{$devices{$hctl}{mp_dev_mm}};
+		push @out_str, "@line_str\n";
+	}
+	@out_str = sort {
+			my @a_fields = split('\s+', $a);
+			my @b_fields = split('\s+', $b);
+
+			$a_fields[3] cmp $b_fields[3]
+				||
+			$a_fields[1] cmp $b_fields[1]
+				||
+			$a_fields[0] cmp $b_fields[0]
+		} @out_str;
+	print @out_str;
+}
+
+sub usage
+{
+    print <<MSG
+Usage: $PROGRAM_NAME [-h] [-v] [-V] [-t <num>] [-i <source>] [-a <adapter>]
+                     [-p <port>] [-l <lun>] [-s <host>] [-d <dev>] [-m <dev>]
+                     [-A] [-D] [-M] [-I]
+
+$PROGRAM_NAME provides information of the multipath, SCSI and FCP configuration
+
+The default is to print the adapter configuration report.
+
+Options:
+
+        -h, --help
+            print this help text.
+
+        -v, --version
+            print version information.
+
+        -t, --topline
+            print a header for column description
+            the default is to print no header which is useful if the results
+            are imported by another application.
+            e.g. $PROGRAM_NAME -D -t
+
+        -i, --input
+            specify a directory or configuration file as source
+            instead of working on the current live-system.
+
+        -a, --adapter
+            limit the output to the list of adapters specified
+            e.g. $PROGRAM_NAME -a 0.0.3c07,0.0.3d07
+
+        -p, --port
+            limit the output to the list of remote-ports specified
+            e.g. $PROGRAM_NAME -D -p 0x5005123456789000,0x5005123456789001
+
+        -l, --lun
+            limit the output to the list of LUNs specified
+            e.g. $PROGRAM_NAME -D -l 0x401040a600000000 -l 0x401040a700000000
+
+        -s, --scsi
+            limit the output to the list SCSI hosts specified
+            e.g. $PROGRAM_NAME -D --scsi host0,host1 -s host5
+
+        -d, --device
+            limit the output to the list of SCSI devices specified
+            e.g. $PROGRAM_NAME -D --device sda,sdb -d sde
+
+        -m, --mdev
+            limit the output to the list of multipath devices specified
+            e.g. $PROGRAM_NAME -M -m 36005076303ffc56200000000000010a6
+
+        -A, --Adapter
+            print the adapter report, this is the default.
+
+        -D, --Device
+            print the device report
+
+        -M, --Map
+            print the multipath, mapper report
+
+        -I, --Internal
+            prints an assembly of data used as input for a variety of reports
+MSG
+}
+
+sub version {
+	print "$PROGRAM_NAME: version %S390_TOOLS_VERSION%\n";
+	print "Copyright IBM Corp. 2008\n";
+}
+
+sub unpack_config
+{
+	my $td = tempdir( CLEANUP => 1 );
+
+	print STDERR "Unpacking configuration ...";
+	system("tar xzf $base_dir -C $td 2>/dev/null");
+	print STDERR "Done.\n";
+
+	$base_dir = $td;
+}
+
+sub verify_and_init
+{
+	# only brief checks if there's something at all #
+	return -1 if (! (-e catdir($base_dir, S_DIR1) &&
+			 -e catdir($base_dir, S_DIR2) &&
+			 -e catdir($base_dir, S_DIR3) &&
+			 -e catdir($base_dir, S_DIR4)));
+
+	get_sub_ch_data($base_dir);
+	get_device_data($base_dir);
+	get_mapper_devices($base_dir);
+	#get_rport_data($base_dir);
+
+	return 0;
+}
+
+##################### main #######################
+my @adapter;
+my @port;
+my @lun;
+my @host;
+my @s_dev;
+my @m_dev;
+my $int_map_list;
+my $adapter_rep;
+my $device_rep;
+my $map_rep;
+my $header = 0;
+
+Getopt::Long::Configure(qw/bundling no_ignore_case/);
+GetOptions('i|input=s' => \$base_dir,
+           'a|adapter=s' => \@adapter,
+           't|topline' => \$header,
+           'h|help' => sub { usage(); exit 0; },
+           'v|version' => sub { version(); exit 0; },
+           'p|port=s' => \@port,
+           'l|lun=s' => \@lun,
+           's|scsi=s' => \@host,
+           'd|device=s' => \@s_dev,
+           'm|mdev=s' => \@m_dev,
+           'I|Internal' => \$int_map_list,
+           'A|Adapter' => \$adapter_rep,
+           'D|Device' => \$device_rep,
+           'M|Map' => \$map_rep,
+          ) or do {
+	print "Invalid usage !\n";
+	usage();
+	exit 1;
+};
+
+if (scalar(@ARGV)) {
+	print "$PROGRAM_NAME: extra operand '@ARGV'\n";
+	print "Try '$PROGRAM_NAME --help' for more information.\n";
+	exit 2;
+}
+
+if (-f $base_dir) {
+	unpack_config();
+}
+
+if (verify_and_init() != 0) {
+	print "No valid configuration found.\nTerminating\n\n";
+	exit 4;
+}
+
+@adapter = split(',', join(',', @adapter));
+@port = split(',', join(',', @port));
+@lun = split(',', join(',', @lun));
+@host = split(',', join(',', @host));
+@s_dev = split(',', join(',', @s_dev));
+@m_dev = split(',', join(',', @m_dev));
+
+if ($int_map_list) {
+	mapping_table();
+	exit 0;
+}
+
+if ($adapter_rep || !($device_rep || $map_rep)) {
+	adapter_report(@adapter);
+}
+
+if ($device_rep) {
+	device_report(\@adapter, \@port, \@lun, \@s_dev, \@host, $header);
+}
+
+if ($map_rep) {
+	mapper_report(\@adapter, \@port, \@s_dev, \@m_dev, $header);
+}
+
Index: s390-tools-sles11/ziomon/ziorep_filters.cpp
===================================================================
--- /dev/null
+++ s390-tools-sles11/ziomon/ziorep_filters.cpp
@@ -0,0 +1,516 @@
+/*
+ * FCP report generators
+ *
+ * Classes implementing various filters
+ *
+ * Copyright IBM Corp. 2008
+ * Author(s): Stefan Raspl <raspl@linux.vnet.ibm.com>
+ */
+
+#include <assert.h>
+#include <unistd.h>
+#define __STDC_LIMIT_MACROS
+#include <stdint.h>
+#include <stdlib.h>
+
+#include "ziorep_filters.hpp"
+
+extern "C" {
+#include "ziomon_msg_tools.h"
+}
+
+extern const char *toolname;
+extern int verbose;
+
+
+
+MsgFilter::MsgFilter()
+{
+}
+
+
+MsgFilter::~MsgFilter()
+{
+}
+
+
+MsgTypeFilter::MsgTypeFilter()
+{
+}
+
+
+MsgTypeFilter::~MsgTypeFilter()
+{
+}
+
+
+void MsgTypeFilter::add_type(__u32 type)
+{
+	m_types.insert(type);
+}
+
+
+bool MsgTypeFilter::is_eligible(const struct message_preview *msg) const
+{
+	return is_eligible(msg->type);
+}
+
+
+bool MsgTypeFilter::is_eligible(const struct message *msg) const
+{
+	return is_eligible(msg->type);
+}
+
+
+bool MsgTypeFilter::is_eligible(__u32 type) const
+{
+	return (m_types.find(type) != m_types.end());
+}
+
+
+MsgTimeFilter::MsgTimeFilter(__u64 begin, __u64 end) :
+m_begin(begin), m_end(end)
+{
+	assert(m_end >= m_begin);
+}
+
+
+MsgTimeFilter::~MsgTimeFilter()
+{
+}
+
+
+bool MsgTimeFilter::is_eligible(__u64 timestamp) const
+{
+	return (timestamp >= m_begin && timestamp <= m_end);
+}
+
+
+__u64 MsgTimeFilter::get_begin_time() const
+{
+	return m_begin;
+}
+
+
+__u64 MsgTimeFilter::get_end_time() const
+{
+	return m_end;
+}
+
+
+bool MsgTimeFilter::is_eligible(const struct message_preview *msg) const
+{
+	return is_eligible(msg->timestamp);
+}
+
+
+bool MsgTimeFilter::is_eligible(const struct message *msg) const
+{
+	return is_eligible(get_timestamp_from_msg(msg));
+}
+
+
+void DeviceFilter::add_device(__u32 device, const struct hctl_ident *id) {
+	add_device(device);
+	add_device(id);
+	add_host(id->host);
+}
+
+
+void DeviceFilter::add_device(__u32 device)
+{
+	list<__u32>::iterator i;
+
+	for (i = m_devices.begin(); i != m_devices.end() && device > *i; ++i);
+
+	if (m_devices.size() == 0 || *i != device)
+		m_devices.insert(i, device);
+}
+
+
+void DeviceFilter::add_device(const struct hctl_ident *id)
+{
+	list<struct hctl_ident>::iterator i;
+
+	for (i = m_idents.begin(); i != m_idents.end()
+	      && compare_hctl_idents(id, &(*i)) > 0; ++i);
+
+	if (m_idents.size() == 0 || i == m_idents.end()
+	    || compare_hctl_idents(&(*i), id) != 0)
+		m_idents.insert(i, *id);
+}
+
+
+void DeviceFilter::add_host(__u32 host)
+{
+	list<__u32>::iterator i;
+
+	for (i = m_host_ids.begin(); i != m_host_ids.end() && host > *i; ++i);
+
+	if (m_host_ids.size() == 0 || i == m_host_ids.end() || *i != host)
+		m_host_ids.insert(i, host);
+}
+
+
+const list<__u32>& DeviceFilter::get_host_id_list() const
+{
+	return m_host_ids;
+}
+
+
+const list<__u32>& DeviceFilter::get_mm_list() const
+{
+	return m_devices;
+}
+
+
+bool DeviceFilter::is_eligible(const struct message *msg,
+				  const struct file_header *hdr) const
+{
+	if (msg->type == hdr->msgid_blkiomon)
+		return is_eligible_mm(((struct blkiomon_stat *)msg->data)->device);
+
+	assert(msg->type == hdr->msgid_zfcpdd);
+
+	return is_eligible_mm(((struct zfcpdd_dstat *)msg->data)->device);
+}
+
+
+bool DeviceFilter::is_eligible(const struct adapter_utilization *res) const
+{
+	return is_eligible_host_id(res->adapter_no);
+}
+
+
+bool DeviceFilter::is_eligible(const struct ioerr_cnt *cnt) const
+{
+	return is_eligible_ident(&cnt->identifier);
+}
+
+
+bool DeviceFilter::is_eligible_mm(__u32 mm) const
+{
+	for (list<__u32>::const_iterator i = m_devices.begin();
+	      i != m_devices.end() && mm >= *i; ++i) {
+		if (mm == *i)
+			return true;
+	}
+
+	return false;
+}
+
+
+bool DeviceFilter::is_eligible_ident(const struct hctl_ident *ident) const
+{
+	int rc;
+
+	for (list<struct hctl_ident>::const_iterator i = m_idents.begin();
+	      i != m_idents.end(); ++i) {
+		rc = compare_hctl_idents(ident, &(*i));
+		if (rc == 0)
+			return true;
+		if (rc < 0)
+			break;
+	}
+
+	return false;
+}
+
+
+bool DeviceFilter::is_eligible_host_id(__u32 host) const
+{
+	for (list<__u32>::const_iterator i = m_host_ids.begin();
+	      i != m_host_ids.end() && host >= (*i); ++i) {
+		if (host == (*i))
+			return true;
+	}
+
+	return false;
+}
+
+
+void DeviceFilter::get_eligible_chpids(ConfigReader &cfg, list<__u32> &lst) const
+{
+	int rc = 0;
+
+	lst.clear();
+	for (list<__u32>::const_iterator i = m_host_ids.begin();
+	      i != m_host_ids.end(); ++i) {
+		lst.push_back(cfg.get_chpid_by_host_id(*i, &rc));
+		assert(rc == 0);
+	}
+}
+
+
+void DeviceFilter::get_eligible_devnos(ConfigReader &cfg, list<__u32> &lst) const
+{
+	if (m_host_ids.size() == 0)
+		cfg.get_unique_devnos(lst);
+	else {
+		lst.clear();
+		list<__u32> tmp;
+		for (list<__u32>::const_iterator i = m_host_ids.begin();
+		      i != m_host_ids.end(); ++i) {
+			cfg.get_devnos_by_host_id(tmp, *i);
+			lst.insert(lst.begin(), tmp.begin(), tmp.end());
+		}
+		lst.sort();
+		lst.unique();
+	}
+}
+
+void DeviceFilter::get_eligible_wwpns(ConfigReader &cfg, list<__u64> &lst) const
+{
+	if (m_devices.size() == 0)
+		cfg.get_unique_wwpns(lst);
+	else {
+		int rc = 0;
+
+		lst.clear();
+		for (list<__u32>::const_iterator i = m_devices.begin();
+		      i != m_devices.end(); ++i) {
+			lst.push_back(cfg.get_wwpn_by_mm_internal(*i, &rc));
+			assert(rc == 0);
+		}
+		lst.sort();
+		lst.unique();
+	}
+}
+
+void DeviceFilter::get_eligible_mp_mms(ConfigReader &cfg, list<__u32> &lst) const
+{
+	if (m_devices.size() == 0)
+		cfg.get_unique_mp_mms(lst);
+	else {
+		int rc = 0;
+		__u32 mp_mm;
+
+		lst.clear();
+		for (list<__u32>::const_iterator i = m_devices.begin();
+		      i != m_devices.end(); ++i) {
+			mp_mm = cfg.get_mp_mm_by_mm_internal(*i, &rc);
+			assert(rc == 0);
+			if (mp_mm)
+				lst.push_back(mp_mm);
+		}
+		lst.sort();
+		lst.unique();
+	}
+}
+
+
+void StagedDeviceFilter::stage_wwpn(__u64 w)
+{
+	list<__u64>::iterator i;
+
+	for (i = m_wwpns.begin(); i != m_wwpns.end() && w > *i; ++i);
+
+	if (m_wwpns.size() == 0 || i == m_wwpns.end() || w != *i)
+		m_wwpns.insert(i, w);
+}
+
+
+void StagedDeviceFilter::stage_mp_mm(__u32 mp_mm)
+{
+	list<__u32>::iterator i;
+
+	for (i = m_mp_mms.begin(); i != m_mp_mms.end() && mp_mm > *i; ++i);
+
+	if (m_mp_mms.size() == 0 || i == m_mp_mms.end() || mp_mm != *i)
+		m_mp_mms.insert(i, mp_mm);
+}
+
+
+void StagedDeviceFilter::stage_devno(__u32 d)
+{
+	list<__u32>::iterator i;
+
+	for (i = m_devnos.begin(); i != m_devnos.end() && d > *i; ++i);
+
+	if (m_devnos.size() == 0 || i == m_devnos.end() || d != *i)
+		m_devnos.insert(i, d);
+}
+
+
+void StagedDeviceFilter::stage_chpid(__u32 c)
+{
+	list<__u32>::iterator i;
+
+	for (i = m_chpids.begin(); i != m_chpids.end() && c > *i; ++i);
+
+	if (m_chpids.size() == 0 || i == m_chpids.end() || c != *i)
+		m_chpids.insert(i, c);
+}
+
+
+const list<__u64>& StagedDeviceFilter::get_filter_wwpns()
+{
+	return m_wwpns;
+}
+
+
+const list<__u32>& StagedDeviceFilter::get_filter_chpids()
+{
+	return m_chpids;
+}
+
+
+const list<__u32>& StagedDeviceFilter::get_filter_devnos()
+{
+	return m_devnos;
+}
+
+
+const list<__u32>& StagedDeviceFilter::get_filter_mp_mms()
+{
+	return m_mp_mms;
+}
+
+
+void StagedDeviceFilter::add_mm_with_host(ConfigReader &cfg, __u32 mm, int *rc)
+{
+	const struct hctl_ident *ident = cfg.get_ident_by_mm_internal(mm, rc);
+	assert(*rc == 0);
+
+	add_device(mm, ident);
+	add_host(ident->host);
+}
+
+
+void StagedDeviceFilter::add_mms_with_host(ConfigReader &cfg, list<__u32> &mms, int *rc)
+{
+	for (list<__u32>::const_iterator i = mms.begin();
+	      i != mms.end(); ++i)
+		add_mm_with_host(cfg, *i, rc);
+}
+
+
+bool StagedDeviceFilter::check_wwpn(__u32 mm, ConfigReader &cfg, int *rc)
+{
+	if (m_wwpns.size() == 0)
+		return true;
+
+	__u64	wwpn = cfg.get_wwpn_by_mm_internal(mm, rc);
+	for (list<__u64>::const_iterator i = m_wwpns.begin();
+	      i != m_wwpns.end(); ++i) {
+		if (*i == wwpn)
+			return true;
+	}
+
+	return false;
+}
+
+
+bool StagedDeviceFilter::check_mm(__u32 mm, ConfigReader &cfg, int *rc)
+{
+	if (m_devices.size() == 0)
+		return true;
+
+	for (list<__u32>::const_iterator i = m_devices.begin();
+	      i != m_devices.end(); ++i) {
+		if (*i == mm)
+			return true;
+	}
+
+	return false;
+}
+
+
+bool StagedDeviceFilter::check_devno(__u32 mm, ConfigReader &cfg, int *rc)
+{
+	if (m_devnos.size() == 0)
+		return true;
+
+	__u32	devno = cfg.get_devno_by_mm_internal(mm, rc);
+	for (list<__u32>::const_iterator i = m_devnos.begin();
+	      i != m_devnos.end(); ++i) {
+		if (*i == devno)
+			return true;
+	}
+
+	return false;
+}
+
+
+bool StagedDeviceFilter::check_chpid(__u32 mm, ConfigReader &cfg, int *rc)
+{
+	if (m_chpids.size() == 0)
+		return true;
+
+	__u32	chpid = cfg.get_chpid_by_mm_internal(mm, rc);
+	for (list<__u32>::const_iterator i = m_chpids.begin();
+	      i != m_chpids.end(); ++i) {
+		if (*i == chpid)
+			return true;
+	}
+
+	return false;
+}
+
+
+bool StagedDeviceFilter::check_mp_device(__u32 mm, ConfigReader &cfg, int *rc)
+{
+	if (m_mp_mms.size() == 0)
+		return true;
+
+	__u32 mp = cfg.get_mp_mm_by_mm_internal(mm, rc);
+	assert(mp);
+	for (list<__u32>::const_iterator i = m_mp_mms.begin();
+	      i != m_mp_mms.end(); ++i) {
+		if (*i == mp)
+			return true;
+	}
+
+	return false;
+}
+
+
+int StagedDeviceFilter::finish(ConfigReader &cfg, bool intersect)
+{
+	int rc = 0;
+	list<__u32> mm_lst;
+
+	if (intersect) {
+		bool found_something = false;
+		cfg.get_unique_mms(mm_lst);
+		for (list<__u32>::const_iterator i = mm_lst.begin();
+		      i != mm_lst.end(); ++i) {
+			if (   check_chpid(*i, cfg, &rc)
+			    && check_mp_device(*i, cfg, &rc)
+			    && check_devno(*i, cfg, &rc)
+			    && check_wwpn(*i, cfg, &rc)
+			    && check_mm(*i, cfg, &rc)) {
+				found_something = true;
+				add_mm_with_host(cfg, *i, &rc);
+			}
+		}
+		if (!rc && !found_something)
+			rc = 1;
+	}
+	else {
+		for (list<__u64>::const_iterator i = m_wwpns.begin();
+		      i != m_wwpns.end(); ++i) {
+			cfg.get_mms_by_wwpn(mm_lst, *i);
+			add_mms_with_host(cfg, mm_lst, &rc);
+		}
+		for (list<__u32>::const_iterator i = m_mp_mms.begin();
+		      i != m_mp_mms.end(); ++i) {
+			cfg.get_mms_by_mp_mm(mm_lst, *i);
+			add_mms_with_host(cfg, mm_lst, &rc);
+		}
+		for (list<__u32>::const_iterator i = m_devnos.begin();
+		      i != m_devnos.end(); ++i) {
+			cfg.get_mms_by_devno(mm_lst, *i);
+			add_mms_with_host(cfg, mm_lst, &rc);
+		}
+		for (list<__u32>::const_iterator i = m_chpids.begin();
+		      i != m_chpids.end(); ++i) {
+			cfg.get_mms_by_chpid(mm_lst, *i);
+			add_mms_with_host(cfg, mm_lst, &rc);
+		}
+	}
+
+	return rc;
+}
+
+
Index: s390-tools-sles11/ziomon/ziorep_filters.hpp
===================================================================
--- /dev/null
+++ s390-tools-sles11/ziomon/ziorep_filters.hpp
@@ -0,0 +1,214 @@
+/*
+ * FCP report generators
+ *
+ * Classes implementing various filters
+ *
+ * Copyright IBM Corp. 2008
+ * Author(s): Stefan Raspl <raspl@linux.vnet.ibm.com>
+ */
+
+#ifndef ZIOREP_FILTERS
+#define ZIOREP_FILTERS
+
+#include <list>
+#include <set>
+
+
+#include "ziorep_cfgreader.hpp"
+
+
+using std::list;
+using std::set;
+
+extern "C" {
+#include "blkiomon.h"
+#include "ziomon_zfcpdd.h"
+}
+
+
+enum MsgTypes {
+	utilization,
+	ioerr,
+	blkiomon,
+	zfcpdd
+};
+
+
+class MsgFilter {
+protected:
+	virtual ~MsgFilter();
+
+	MsgFilter();
+
+public:
+	/** Returns 'true' if the message should be kept,
+	 * 'false' in case it should be filtered
+	 */
+	virtual bool is_eligible(const struct message_preview *msg) const = 0;
+
+	/** Returns 'true' if the message should be kept,
+	 * 'false' in case it should be filtered
+	 */
+	virtual bool is_eligible(const struct message *msg) const = 0;
+};
+
+
+class MsgTypeFilter : public MsgFilter {
+public:
+	virtual ~MsgTypeFilter();
+
+	MsgTypeFilter();
+
+	/// add type that should be kept
+	void add_type(__u32 type);
+
+	virtual bool is_eligible(const struct message_preview *msg) const;
+
+	virtual bool is_eligible(const struct message *msg) const;
+
+private:
+	bool is_eligible(__u32 type) const;
+
+	/// types to keep
+	set<__u32>	m_types;
+};
+
+
+class MsgTimeFilter : public MsgFilter {
+public:
+	virtual ~MsgTimeFilter();
+
+	/// add type that should be kept
+	MsgTimeFilter(__u64 begin, __u64 end);
+
+	virtual bool is_eligible(const struct message_preview *msg) const;
+
+	/**
+	 * NOTE: Message must be in native endianess! */
+	virtual bool is_eligible(const struct message *msg) const;
+
+	__u64	get_begin_time() const;
+	__u64	get_end_time() const;
+
+private:
+	bool is_eligible(__u64 timestamp) const;
+
+	__u64		m_begin;
+	__u64		m_end;
+};
+
+
+/**
+ * Class to filter messages by the device they refer to, where
+ * the device can be of any type.
+ */
+class DeviceFilter {
+public:
+	void add_device(__u32 device, const struct hctl_ident *id);
+
+	const list<__u32>& get_host_id_list() const;
+	const list<__u32>& get_mm_list() const;
+
+	/** Returns 'true' if the message should be kept,
+	 * 'false' in case it should be filtered
+	 */
+	bool is_eligible(const message *msg, const struct file_header *hdr) const;
+	bool is_eligible(const struct adapter_utilization *res) const;
+	bool is_eligible(const struct ioerr_cnt *cnt) const;
+
+	bool is_eligible_mm(__u32 mm) const;
+	bool is_eligible_ident(const struct hctl_ident *ident) const;
+	bool is_eligible_host_id(__u32 host) const;
+
+	/** Returns a list of all chpids that are eligible according to
+	 * the filter criteria. */
+	void get_eligible_chpids(ConfigReader &cfg, list<__u32> &lst) const;
+
+	/** Returns a list of all devnos that are eligible according to
+	 * the filter criteria. */
+	void get_eligible_devnos(ConfigReader &cfg, list<__u32> &lst) const;
+
+	/** Returns a list of all wwpns that are eligible according to
+	 * the filter criteria. */
+	void get_eligible_wwpns(ConfigReader &cfg, list<__u64> &lst) const;
+
+	/** Returns a list of all mp_mms that are eligible according to
+	 * the filter criteria. */
+	void get_eligible_mp_mms(ConfigReader &cfg, list<__u32> &lst) const;
+
+protected:
+	void add_host(__u32 host_id);
+	/// ascending list of devices to keep - in sync with m_idents
+	list<__u32>			m_devices;
+
+private:
+	void add_device(__u32 device);
+	void add_device(const struct hctl_ident *id);
+
+	/// ascending list of HBAs to keep
+	list<__u32>			m_host_ids;
+	/// ascending list of devices to keep - in sync with m_devices
+	list<struct hctl_ident>		m_idents;
+};
+
+/**
+ * Special kind of DeviceFilter: Add all criteria to it and finally
+ * decide whether devices should be filtered by (a) either criterion
+ * or (b) only the intersection of the criteria.
+ * Internally, we store all submitted data in separate structures. When
+ * the user hits 'finished', the data will be analyzed and transferred to
+ * the base class.
+ */
+class StagedDeviceFilter : public DeviceFilter {
+public:
+	void stage_wwpn(__u64 wwpn);
+	void stage_mp_mm(__u32 mp_mm);
+	void stage_devno(__u32 sub);
+	void stage_chpid(__u32 chpid);
+
+	/**
+	  * retrieve an ordered list of the wwpns as they were specified
+	  * for filtering. */
+	const list<__u64>& get_filter_wwpns();
+	/**
+	  * retrieve an ordered list of the chpids as they were specified
+	  * for filtering. */
+	const list<__u32>& get_filter_chpids();
+	/**
+	  * retrieve an ordered list of the devnos as they were specified
+	  * for filtering. */
+	const list<__u32>& get_filter_devnos();
+	/**
+	  * retrieve an ordered list of the mp_mms as they were specified
+	  * for filtering. */
+	const list<__u32>& get_filter_mp_mms();
+
+	/**
+	 * Call this method prior to actually using the class.
+	 * If 'intersect' is enabled, a positive return code indicates
+	 * that the intersection is empty. <0 means error, 0 in success.
+	 */
+	int finish(ConfigReader &cfg, bool intersect);
+
+private:
+	void add_mm_with_host(ConfigReader &cfg, __u32 mm, int *rc);
+	void add_mms_with_host(ConfigReader &cfg, list<__u32> &mms, int *rc);
+	/// check if 'mm's wwpn is eligible
+	bool check_wwpn(__u32 mm, ConfigReader &cfg, int *rc);
+	/// check if 'mm' is eligible
+	bool check_mm(__u32 mm, ConfigReader &cfg, int *rc);
+	/// check if 'mm's devo is eligible
+	bool check_devno(__u32 mm, ConfigReader &cfg, int *rc);
+	/// check if 'mm's chpid is eligible
+	bool check_chpid(__u32 mm, ConfigReader &cfg, int *rc);
+	/// check if 'mm's mp is eligible
+	bool check_mp_device(__u32 mm, ConfigReader &cfg, int *rc);
+
+	list<__u64>		m_wwpns;
+	list<__u32>		m_devnos;
+	list<__u32>		m_chpids;
+	list<__u32>		m_mp_mms;
+};
+
+#endif
+
